// AddLineDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxTeleServerApp.h"
#include "VaxTeleServerAppDlg.h"
#include "AddLineDlg.h"
#include "Codec.h"

#include "VaxServerSIP.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddLineDlg dialog


CAddLineDlg::CAddLineDlg(CVaxServerSIP* pVaxTeleSIP) : CPropertyPage(CAddLineDlg::IDD)
{
	//{{AFX_DATA_INIT(CAddLineDlg)

	m_sRoomName = _T("");
	m_sConnectToLogin = _T("");
	m_sQueueName = _T("");
	m_sRingGroupName = _T("");
	
	m_sLineDisplayName = _T("");
	m_sLineUserName = _T("");
	m_sLineAuthUser = _T("");
	m_sLinePassword = _T("");
	m_sLineRealm = _T("");
	m_sLineProxy = _T("");
	m_bStartupReg = FALSE;
	m_sLineName = _T("");

	m_nRadioCtrlBtn = 0;

	m_psp.dwFlags &= ~PSP_HASHELP;  // Lose the Help button

	m_pVaxTeleSIP = pVaxTeleSIP;
}


void CAddLineDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddLineDlg)
	DDX_Control(pDX, IDC_COMBO_LINE_CONNECT_USER, m_ctrlComboConnectToLogin);
	DDX_Control(pDX, IDC_COMBO_LINE, m_ctrlComboLine);
	DDX_Control(pDX, IDC_LIST_LINE_DISABLE_CODEC, m_ctrlDisableCodecList);
	DDX_Control(pDX, IDC_LIST_LINE_ENABLE_CODEC, m_ctrlEnableCodecList);
	DDX_Text(pDX, IDC_EDIT_LINE_DISPLAY_NAME, m_sLineDisplayName);
	DDX_Text(pDX, IDC_EDIT_LINE_USER_NAME, m_sLineUserName);
	DDX_Text(pDX, IDC_EDIT_LINE_AUTH_USER, m_sLineAuthUser);
	DDX_Text(pDX, IDC_EDIT_LINE_PASSWORD, m_sLinePassword);
	DDX_Text(pDX, IDC_EDIT_LINE_DOMAIN_REALM, m_sLineRealm);
	DDX_Text(pDX, IDC_EDIT_LINE_SIP_PROXY, m_sLineProxy);
	DDX_Check(pDX, IDC_CHECK_REG_START_UP, m_bStartupReg);
	DDX_CBString(pDX, IDC_COMBO_LINE, m_sLineName);

	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_COMBO_LINE_CONNECT_ROOM, m_ctrlComboConnectToRoom);
	DDX_CBString(pDX, IDC_COMBO_LINE_CONNECT_ROOM, m_sRoomName);
	DDX_CBString(pDX, IDC_COMBO_LINE_CONNECT_USER, m_sConnectToLogin);
	DDX_Control(pDX, IDC_COMBO_LINE_CONNECT_TO_QUEUE, m_objComboQueueList);
	DDX_Control(pDX, IDC_COMBO_LINE_CONNECT_TO_GROUP, m_objComboRingGroupList);
	DDX_CBString(pDX, IDC_COMBO_LINE_CONNECT_TO_QUEUE, m_sQueueName);
	DDX_CBString(pDX, IDC_COMBO_LINE_CONNECT_TO_GROUP, m_sRingGroupName);

	DDX_Radio(pDX, IDC_RADIO_LINE_REJECT_CALL, m_nRadioCtrlBtn);
}


BEGIN_MESSAGE_MAP(CAddLineDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CAddLineDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_LINE, OnSelchangeComboLine)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_LINE_DLG, OnButtonClearLineDlg)
	ON_BN_CLICKED(IDC_BUTTON_LINE_DISABLE_CODEC, OnButtonLineDisableCodec)
	ON_BN_CLICKED(IDC_BUTTON_LINE_ENABLE_CODEC, OnButtonLineEnableCodec)
	ON_BN_CLICKED(IDC_BUTTON_LINE_ADD, OnButtonLineAdd)
	ON_BN_CLICKED(IDC_BUTTON_LINE_REMOVE, OnButtonLineRemove)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddLineDlg message handlers

BOOL CAddLineDlg::OnSetActive()
{
	AddLines();
	
	AddUsers();
	AddRooms();
	
	AddQueues();
	AddRingGroups();

	ShowLineDetails();

	return CPropertyPage::OnSetActive();
}

BOOL CAddLineDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_ctrlComboLine.SetWindowPos(NULL,0,0,140,150,SWP_NOMOVE|SWP_NOZORDER);
	m_ctrlComboConnectToLogin.SetWindowPos(NULL,0,0,120,150,SWP_NOMOVE|SWP_NOZORDER);
	m_ctrlComboConnectToRoom.SetWindowPos(NULL,0,0,120,150,SWP_NOMOVE|SWP_NOZORDER);

	UpdateData(FALSE);

	LoadCodecs();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CAddLineDlg::OnButtonLineDisableCodec() 
{
	int nCurSel = m_ctrlEnableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	m_ctrlEnableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlEnableCodecList.DeleteString(nCurSel);
	
	m_ctrlDisableCodecList.AddString(sCurSelText);
	
}

void CAddLineDlg::OnButtonLineEnableCodec() 
{
	int nCurSel = m_ctrlDisableCodecList.GetCurSel();
	if(nCurSel == -1) return;

	CString sCurSelText;
	
	m_ctrlDisableCodecList.GetText(nCurSel, sCurSelText);
	m_ctrlDisableCodecList.DeleteString(nCurSel);
	
	m_ctrlEnableCodecList.AddString(sCurSelText);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CAddLineDlg::OnButtonLineAdd() 
{
	UpdateData();
	
	if(!AddLineChecks())
		return;
	
	if(m_ctrlComboLine.FindStringExact(0, m_sLineName) != -1)
	{
		if(MessageBox("Line already exists, do you want to continue?", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_YESNO) == IDNO)
			return;
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////

	CCodec objCodec;
	CString sCodecList;
		
	for(int nCount = 0; nCount < m_ctrlEnableCodecList.GetCount(); nCount++)
	{
		CString sCodecText;
		m_ctrlEnableCodecList.GetText(nCount, sCodecText);

		sCodecList += objCodec.GetCodecNo(sCodecText);
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////

	CString sToPeerName, sRoomName, sQueueName, sRingGroupName;
	BOOL bRejected = FALSE; int nToPeerType = -1;

 	if(m_nRadioCtrlBtn == 0)
		bRejected = TRUE;

	else if(m_nRadioCtrlBtn == 1)
	{
		nToPeerType = VAX_PEER_TYPE_USER;
		sToPeerName = m_sConnectToLogin;
	}
	else if(m_nRadioCtrlBtn == 2)
	{
		sRoomName = m_sRoomName;
	}

	else if(m_nRadioCtrlBtn == 3)
	{
		sQueueName = m_sQueueName;
	}
	else if(m_nRadioCtrlBtn == 4)
	{
		sRingGroupName = m_sRingGroupName;
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////

	m_pVaxTeleSIP->RemoveLine(m_sLineName);

	if(!m_pVaxTeleSIP->AddLine(m_sLineName, m_sLineDisplayName, m_sLineUserName, m_sLineAuthUser, m_sLinePassword, m_sLineRealm, m_sLineProxy, sCodecList, m_bStartupReg, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName))
	{
		MessageBox("Line could not be added/updated or Please start the server first.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
		
	if(m_ctrlComboLine.FindStringExact(0, m_sLineName) == -1)
		m_ctrlComboLine.AddString(m_sLineName);
			
	MessageBox("Line added/updated successfully.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
}

void CAddLineDlg::OnButtonLineRemove()
{
	UpdateData();
	
	if(m_sLineName.IsEmpty())
	{
		MessageBox("Please enter a Line Name.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return;
	}
	
	int nIndex = m_ctrlComboLine.FindStringExact(0, m_sLineName);
	if(nIndex == -1) return;

	m_pVaxTeleSIP->RemoveLine(m_sLineName);
	m_ctrlComboLine.DeleteString(nIndex);
	
	ClearDlgContent();
	
	if(m_ctrlComboLine.GetCount() > 0)
		m_ctrlComboLine.SetCurSel(0);
		
	ShowLineDetails();
	
	MessageBox("Line removed successfully!", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CAddLineDlg::OnSelchangeComboLine() 
{
	ShowLineDetails();
}

void CAddLineDlg::OnButtonClearLineDlg() 
{
	ClearDlgContent();
}

void CAddLineDlg::ClearDlgContent()
{
	m_ctrlComboConnectToLogin.SetCurSel(0);
	
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	m_ctrlEnableCodecList.AddString(G711U_TEXT);
	m_ctrlEnableCodecList.AddString(G711A_TEXT);
	m_ctrlEnableCodecList.AddString(ILBC_TEXT);
	m_ctrlEnableCodecList.AddString(G610_TEXT);
	m_ctrlEnableCodecList.AddString(G729_TEXT);

	m_sLineName	           = "";
	m_sLineDisplayName	   = "";
	m_sLineUserName		   = "";
	m_sLineAuthUser		   = "";
	m_sLinePassword		   = "";
	m_sLineRealm		   = "";
	m_sLineProxy		   = "";
	m_bStartupReg		   = FALSE;
	
	m_nRadioCtrlBtn = 0;
	
	UpdateData(FALSE);
}

void CAddLineDlg::LoadCodecs()
{
	CCodec objCodec;
	
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	for(char cCodec = '0'; cCodec < TOTAL_NO_CODEC; cCodec++)	
		m_ctrlEnableCodecList.AddString(objCodec.GetCodecName(cCodec));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CAddLineDlg::AddLines()
{
	m_ctrlComboLine.ResetContent();

	CStringList objProxyList;
	m_pVaxTeleSIP->GetLineAll(&objProxyList);
		
	while(!objProxyList.IsEmpty())
		m_ctrlComboLine.AddString(objProxyList.RemoveHead());

	if(m_ctrlComboLine.GetCount() > 0)
		m_ctrlComboLine.SetCurSel(0);
}

void CAddLineDlg::AddUsers()
{
	m_ctrlComboConnectToLogin.ResetContent();

	CStringList objListUsers;
	m_pVaxTeleSIP->GetUserAll(&objListUsers);

	while(!objListUsers.IsEmpty())
		m_ctrlComboConnectToLogin.AddString(objListUsers.RemoveHead());
			
	if(m_ctrlComboConnectToLogin.GetCount() > 0)
		m_ctrlComboConnectToLogin.SetCurSel(0);
}

void CAddLineDlg::AddRooms()
{
	m_ctrlComboConnectToRoom.ResetContent();

	CStringList objRoomList;
	m_pVaxTeleSIP->GetRoomAll(&objRoomList);

	if(objRoomList.GetCount() <= 0) return;

	while(!objRoomList.IsEmpty())
		m_ctrlComboConnectToRoom.AddString(objRoomList.RemoveHead());
		
	if(m_ctrlComboConnectToRoom.GetCount() > 0)
		m_ctrlComboConnectToRoom.SetCurSel(0);
}

void CAddLineDlg::AddQueues()
{
	m_objComboQueueList.ResetContent();

	CStringList sListQueueName;
	m_pVaxTeleSIP->GetQueueNameAll(&sListQueueName);
		
	while(!sListQueueName.IsEmpty())
		m_objComboQueueList.AddString(sListQueueName.RemoveHead());

	if(m_objComboQueueList.GetCount() > 0)
		m_objComboQueueList.SetCurSel(0);
}

void CAddLineDlg::AddRingGroups()
{
	m_objComboRingGroupList.ResetContent();
	
	CStringList sListRingGroupName;
	m_pVaxTeleSIP->GetRingGroupNameAll(&sListRingGroupName);
		
	while(!sListRingGroupName.IsEmpty())
		m_objComboRingGroupList.AddString(sListRingGroupName.RemoveHead());

	if(m_objComboRingGroupList.GetCount() > 0)
		m_objComboRingGroupList.SetCurSel(0);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CAddLineDlg::AddLineChecks()
{
	UpdateData();
	
	if(m_sLineName.IsEmpty())
	{
		MessageBox("Please enter a Line Name.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}
		
	if(m_ctrlEnableCodecList.GetCount() == 0)
	{
		MessageBox("Please select a codec.", "VaxTeleSIP", MB_ICONEXCLAMATION|MB_OK);
		return FALSE;
	}

	return TRUE;
}

void CAddLineDlg::ShowLineDetails()
{
	int nCurIndex = m_ctrlComboLine.GetCurSel();
	if(nCurIndex == -1) return;

	CString sLineName;
	m_ctrlComboLine.GetLBText(nCurIndex, sLineName);
	
	CString sDisplayName; CString sUserName; CString sAuthUser; 
	CString sAuthPwd; CString sDomainRealm; CString sProxySIP; 
	CString sOutboundProxy; CString sCodecList;
	CString	sToPeerName, sRoomName,  sQueueName, sRingGroupName;

	int nToPeerType = -1;
	BOOL bRegister, bRejected;

	m_pVaxTeleSIP->GetLineDetails(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bRejected, sRoomName,  sQueueName, sRingGroupName);
	UpdateDlgContent(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sProxySIP, sCodecList, bRegister, nToPeerType, sToPeerName, bRejected, sRoomName, sQueueName, sRingGroupName);
}

void CAddLineDlg::UpdateIncomingCallSection(int nToPeerType, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName)
{
	if(bRejected)
	{
		m_nRadioCtrlBtn = 0;
	}

	else if(nToPeerType == VAX_PEER_TYPE_USER)
	{
		m_nRadioCtrlBtn = 1;
		m_ctrlComboConnectToLogin.SelectString(0, sToPeerName);
	}

	else if(!CString(sRoomName).IsEmpty())
	{
		m_nRadioCtrlBtn = 2;
		m_ctrlComboConnectToRoom.SelectString(0, sRoomName);
	}

	else if(!CString(sQueueName).IsEmpty())
	{
		m_nRadioCtrlBtn = 3;
		m_sQueueName = sQueueName;
		m_objComboQueueList.SelectString(0, sQueueName);
	}
	
	else if(!CString(sRingGroupName).IsEmpty())
	{
		m_nRadioCtrlBtn = 4;
		m_sRingGroupName = sRingGroupName;
		m_objComboRingGroupList.SelectString(0, sRingGroupName);
	}
}

void CAddLineDlg::UpdateDlgContent(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sRealm, LPCTSTR sProxy, CString sCodecList, BOOL bRegister, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlock, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName)
{
	UpdateData();
		
	m_sLineName			  = sLineName;
	m_sLineDisplayName	  = sDisplayName;
	m_sLineUserName		  = sUserName;
	m_sLineAuthUser		  = sAuthUser;
	m_sLinePassword		  = sAuthPwd;
	m_sLineRealm		  = sRealm;
	m_sLineProxy		  = sProxy;
	
	m_bStartupReg		  = bRegister;

	UpdateIncomingCallSection(nToPeerType, sToPeerName, bBlock, sRoomName, sQueueName, sRingGroupName);
		
	CCodec objCodec;
	
	m_ctrlEnableCodecList.ResetContent();
	m_ctrlDisableCodecList.ResetContent();

	for(char cCodec = '0'; cCodec < TOTAL_NO_CODEC; cCodec++)	
		m_ctrlDisableCodecList.AddString(objCodec.GetCodecName(cCodec));
		
	for(int nCount = 0; nCount < sCodecList.GetLength(); nCount++)
	{
		CString sCodecName = objCodec.GetCodecName(sCodecList.GetAt(nCount));
		m_ctrlEnableCodecList.AddString(sCodecName);
		
		int nIndex = m_ctrlDisableCodecList.FindStringExact(0, sCodecName);
		if(nIndex == -1) continue;
		
		m_ctrlDisableCodecList.DeleteString(nIndex);
	}
			
	UpdateData(FALSE);
}

void CAddLineDlg::OnDestroy() 
{
	CPropertyPage::OnDestroy();
}