#pragma once

#include "VaxServerExCOM.h"


class CStatusLogDlg;
class CErrorLogDlg;
class CVaxSettingDefault;

class CVaxServerSIP : public CVaxServerExCOM
{

public:

	CStatusLogDlg* m_pStatusLogDlg;
	CErrorLogDlg* m_pErrorLogDlg;

public:

	CVaxServerSIP();
	~CVaxServerSIP();

private:

	CVaxSettingDefault* m_pVaxSettingDefault;

public:

	BOOL Initialize(LPCTSTR sDomainRealm, LPCTSTR sSIPListenIP, int nSIPListenPort);
	BOOL GetInitialize(CString& sSIPListenIP,  int& nSIPListenPort);

	BOOL LoadMusicHold(LPCTSTR sFileName);
	CString GetMusicHold();

	BOOL LoadDialToneMusic(LPCTSTR sFileName);
	CString GetDialToneMusic();

	BOOL LoadMusicCallPark(LPCTSTR sFileName);
    CString GetMusicCallPark();
	
public:

	BOOL AddUser(LPCTSTR sLogin, LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bBlocked, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName, BOOL bStealthlisten);
	void RemoveUser(LPCTSTR sLogin);

	BOOL GetUserDetails(LPCTSTR sUserName, CString& sPassword, CString& sCodecList, BOOL& bBlocked, CString& sUserPrefix, CString& sDialPrefix,  int& nToPeerType, CString& sToPeerName, BOOL& bStealthlisten);
	void GetUserAll(CStringList* pUserList);

	BOOL AddLine(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sCodecList, BOOL bRegister, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlock, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	void RemoveLine(LPCTSTR sLineName);

	void GetLineAll(CStringList* pLineList);
	BOOL GetLineDetails(LPCTSTR sLineName, CString& sDisplayName, CString& sUserName, CString& sAuthUser, CString& sAuthPwd, CString& sDomainRealm, CString& sProxySIP, CString& sCodecList, BOOL& bRegister, int& nToPeerType, CString& sToPeerName, BOOL& bRejected, CString& sRoomName, CString& sQueueName, CString& sRingGroupName);
		
	BOOL AddDirectProxySIP(LPCTSTR sProxyName, LPCTSTR sAuthLogin, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxyIP, LONG lProxyPort, LPCTSTR sCodecList, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlock, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	void RemoveDirectProxySIP(LPCTSTR sProxyName);

	void GetDirectProxyAll(CStringList* pDirectProxyList);
	BOOL GetDirectProxyDetails(LPCTSTR sProxyName, CString& sAuthLogin, CString& sAuthPwd, CString& sDomainRealm, CString& sProxyIP, LONG& lProxyPort, CString& sCodecList, int& nToPeerType, CString& sToPeerName, BOOL& bBlocked, CString& sRoomName, CString& sQueueName, CString& sRingGroupName);

	BOOL AddRoom(LPCTSTR sRoomName, LPCTSTR sRoomNo);
	void RemoveRoom(LPCTSTR sRoomName);

	BOOL GetRoomDetails(LPCTSTR sRoomName, CString& sRoomNo);
	BOOL GetRoomAll(CStringList* pRoomList);

	BOOL AddQueue(LPCTSTR sQueueName, LPCTSTR sQueueMusicFile, LPCTSTR sQueueDialToneFile);
	void RemoveQueue(LPCTSTR sQueueName);

	BOOL GetQueueNameAll(CStringList* sListQueueName);
	BOOL GetQueueDetails(LPCTSTR sQueueName, int& nProcessMode, int& nProcessType, CStringList* sListQueueAgent, CString& sQueueMusicFile, CString& sQueueDialToneFile);
	
	BOOL AddQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName);
	void RemoveQueueAgent(LPCTSTR sQueueName, LPCTSTR sAgentName);
	

	void SetQueueAgentPriority(LPCTSTR sQueueName, LPCTSTR sAgentName, LONG lPriority);
    void SetQueueProcessMode(LPCTSTR sQueueName, int nProcessMode, int nProcessType);

	BOOL AddRingGroup(LPCTSTR sRingGroupName);
    void RemoveRingGroup(LPCTSTR sRingGroupName);

	BOOL GetRingGroupNameAll(CStringList* sListRingGroupName);
	BOOL GetRingGroupDetails(LPCTSTR sRingGroupName, int& nProcessMode, int& nProcessType, CStringList* sListAgentName);

	BOOL AddRingGroupAgent(LPCTSTR sRingGroupName, LPCTSTR sUserName);
	void RemoveRingGroupAgent(LPCTSTR sRingGroupName, LPCTSTR sUserName);

	void SetRingGroupProcessMode(LPCTSTR sRingGroupName, int nProcessMode, int nProcessType);
	BOOL SetRingGroupAgentPriority(LPCTSTR sRingGroupName, LPCTSTR sAgentName, int nPriority);

	BOOL AddCallPickUpGroup(LPCTSTR sPickupGroupName);
	void RemoveCallPickUpGroup(LPCTSTR sPickupGroupName);

    BOOL GetPickUpGroupNameAll(CStringList* sListPickUpName);
	BOOL GetPickUpMemberName(LPCTSTR sPickUpGroupName, CStringList* sListMemberName);

	BOOL AddCallPickUpGroupMember(LPCTSTR sPickupGroupName, LPCTSTR sMemberName);
	void RemoveCallPickUpGroupMember(LPCTSTR sPickupGroupName, LPCTSTR sMemberName);
	
	
private:

	void LoadUser();
	void LoadLine();
	void LoadDirectProxy();

	void LoadRoom();
	void LoadQueue();

	void LoadRingGroup();
	void LoadCallPickupGroup();

	void AddQueueAgents(LPCTSTR sQueueName, CStringList& objListQueueAgent);
	void AddRingGroupAgents(LPCTSTR sRingGroupName,  CStringList& objListRingGroupAgents);
	void AddPickupGroupAgents(LPCTSTR sAddCallPickUpGroupName, CStringList& objListCallPickUpAgents);

private:

	void OnInitialize();
	void OnStatusLog(LPCTSTR sMsg);
	void OnErrorLog(LPCTSTR sMsg);




};

