﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cStoreRingGroup : cStoreRegistry
    {
        const string RING_GROUP_ROOT_PATH = "RingGroups\\";

        public cStoreRingGroup()
        {
        }

        ~cStoreRingGroup()
        {
        }

        //////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////
        
        public bool AddRingGroup(string sRingGroupName)
        {
            if(sRingGroupName.Length == 0)
                return false;

            string sKeyPath = RING_GROUP_ROOT_PATH + sRingGroupName;
            return base.SetTEXT(sKeyPath, "RingGroupName", sRingGroupName);
        }

        public void RemoveRingGroup(string sRingGroupName)
        {
            if(sRingGroupName.Length == 0)
                return;

            string sKeyPath = RING_GROUP_ROOT_PATH + sRingGroupName;
            base.DeleteSubKey(sKeyPath);
        }

        public bool GetRingGroupList(ref List<string> objListRingGroup)
        {
            string sKeyPath = RING_GROUP_ROOT_PATH;
            return base.EnumSubKeys(sKeyPath, ref objListRingGroup);
        }

        ///////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////

        public bool SetRingGroupProcessMode(string sRingGroupName, int nModeId, int nModeType)
        {
            if(sRingGroupName.Length == 0)
                return false;

            string sKeyPath = RING_GROUP_ROOT_PATH + sRingGroupName; ;

            base.SetINT(sKeyPath, "ProcessMode", nModeId);
            base.SetINT(sKeyPath, "ProcessType", nModeType);
            return true;
        }

        public bool GetRingGroupProcessMode(string sRingGroupName, ref int nModeId, ref int nModeType)
        {
            if(sRingGroupName.Length == 0)
                return false;

            string sKeyPath = RING_GROUP_ROOT_PATH + sRingGroupName; ;

            base.GetINT(sKeyPath, "ProcessMode", ref nModeId);
            base.GetINT(sKeyPath, "ProcessType", ref nModeType);
            return true;
        }

        ///////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////
      
        public bool AddRingGroupAgent(string sRingGroupName, string sUserName)
        {
            if(sRingGroupName.Length == 0)
                return false;

            string sKeyPath = RING_GROUP_ROOT_PATH + sRingGroupName + "\\" + sUserName;
            return base.SetTEXT(sKeyPath, "UserName", sUserName);
        }

        public bool RemoveRingGroupAgent(string sRingGroupName, string sUserName)
        {
            if(sRingGroupName.Length == 0)
                return false;

            string sKeyPath = RING_GROUP_ROOT_PATH + sRingGroupName + "\\" + sUserName;
            return base.DeleteSubKey(sKeyPath);
        }

        public bool GetRingGroupAgentList(string sRingGroupName, ref List<string> objListRingGroup)
        {
            if(sRingGroupName.Length == 0)
                return false;

            string sKeyPath = RING_GROUP_ROOT_PATH + sRingGroupName; ;
            return base.EnumSubKeys(sKeyPath, ref objListRingGroup);
        }

        ///////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////

        public bool SetRingGroupAgentPriority(string sRingGroupName, string sUserName, int nPriority)
        {
            if(sRingGroupName.Length == 0)
                return false;

            string sKeyPath = RING_GROUP_ROOT_PATH + sRingGroupName + "\\" + sUserName;
            return base.SetINT(sKeyPath, "Priority", nPriority);
        }

        public bool GetRingGroupAgentPriority(string sRingGroupName, string sUserName, ref int nPriority)
        {
            if(sRingGroupName.Length == 0)
                return false;

            string sKeyPath = RING_GROUP_ROOT_PATH + sRingGroupName + "\\" + sUserName;
            return base.GetINT(sKeyPath, "Priority", ref nPriority);
        }

        public bool IsDataStored()
        {
            return base.IsKeyExist(RING_GROUP_ROOT_PATH);
        }
    }
}
