#include "StdAfx.h"
#include "Define.h"
#include "VaxLine.h"
#include "VaxServerExCOM.h"

CVaxLine::CVaxLine(CVaxServerExCOM* pServerExCOM)
{
	m_pServerExCOM = pServerExCOM;
}

CVaxLine::~CVaxLine()
{
}

void CVaxLine::OnLineRegisterTrying(LPCTSTR sLineName)
{
	CString sStatus;
	sStatus.Format("'%s' %s", sLineName, LINE_REG_TRYING);
	
	m_pServerExCOM->GenStatusLog(sStatus);
}
void CVaxLine::OnLineRegisterFailed(LPCTSTR sLineName, LONG lStatusCode, LPCTSTR sReasonPhrase)
{
	CString sStatus;
	sStatus.Format("'%s' Register Failed: %s", sLineName, sReasonPhrase);
	
	m_pServerExCOM->GenStatusLog(sStatus);
}
void CVaxLine::OnLineRegisterSuccess(LPCTSTR sLineName)
{
	CString sStatus;
	sStatus.Format("'%s' %s", sLineName, LINE_REG_SUCCESS);
	
	m_pServerExCOM->GenStatusLog(sStatus);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////

void CVaxLine::SetData(LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sDomainRealm, LPCTSTR sProxySIP, LPCTSTR sCodecList, BOOL bRegister, int nToPeerType, LPCTSTR sToPeerName, BOOL bBlock, LPCTSTR sRoomName)
{
	m_sDisplayName = sDisplayName;
	m_sUserName    = sUserName;
	
	m_sAuthUser    = sAuthUser;
	m_sAuthPwd     = sAuthPwd;

	m_sDomainRealm = sDomainRealm;
	m_sProxySIP    = sProxySIP;
	
	m_sCodecList   = sCodecList;
	
	m_sToPeerName  = sToPeerName;
	m_nToPeerType  = nToPeerType;
	
	m_sRoomName    = sRoomName;
	
	m_bRegister    = bRegister;
	m_bBlock       = bBlock;
}

void CVaxLine::GetData(CString& sDisplayName, CString& sUserName, CString& sAuthUser, CString& sAuthPwd, CString& sDomainRealm, CString& sProxySIP, CString& sCodecList, BOOL& bRegister, int& nToPeerType, CString& sToPeerName, BOOL& bBlock, CString& sRoomName)
{
	sDisplayName = m_sDisplayName;
	sUserName    = m_sUserName;
	
	sAuthUser    = m_sAuthUser;
	sAuthPwd     = m_sAuthPwd;

	sDomainRealm = m_sDomainRealm;
	sProxySIP    = m_sProxySIP;
	
	sCodecList   = m_sCodecList;
	
	sToPeerName  = m_sToPeerName;
	nToPeerType  = m_nToPeerType;
	
	sRoomName    = m_sRoomName;
	
	bRegister    = m_bRegister;
	bBlock       = m_bBlock;
}

